#!/usr/bin/perl -w
use strict;

my $truthFile = shift or die;
my $sysFile = shift or die;

my $N   = 0;
my %c  = ();
open T, $truthFile or die;
open S, $sysFile or die;
while (my $t = <T>) {
    chomp $t;
    my $s = <S>;
    if (not defined $s) { die "not enough lines in $sysFile\n"; }
    chomp $s;
    ($t) = split /\s+/, $t;
    ($s) = split /\s+/, $s;
    if (not $s =~ /^[0123]$/) { $s = 0; }
    $c{$t}{$s}++;
    $N++;
}
while (<S>) { die "too many lines in $sysFile\n"; }
close T or die;
close S or die;

print "confusion matrix:\n";
print "S \\ T |\t";
foreach my $t (0, 1, 2, 3) {
    print $t . "\t";
}
print "\n";
print "------+-------------------------------\n";
my %pr = ();
foreach my $s (0, 1, 2, 3) {
    print "   $s  |";
    foreach my $t (0, 1, 2, 3) {
        print "\t";
        $c{$t}{$s} += 0;
        print $c{$t}{$s};
    }
    print "\n";
}

my $overallR = 1;
print "\n";
foreach my $t (0, 1, 2, 3) {
    my $T = $c{0}{$t}+$c{1}{$t}+$c{2}{$t}+$c{3}{$t};
    my $rec = ($T>0) ? $c{$t}{$t} / $T : 0;

    print "  recall @ $t: $rec\n";
    $overallR *= $rec;
}
$overallR = sqrt(sqrt($overallR));
print "total recall: $overallR\n";



